' Global variables
Dim oRSS
Dim iCnt, iMaxItems
Dim Nodes, Node
Dim sChannelName, sChannelURL, sChannelSelection
Dim sProperty

' Initialize
iMaxItems = 5
iCnt = 0

sChannelSelection = GetPropertyValue("News.News Channel Selection")

If CheckChannel(sChannelSelection) then
	Set oRSS = CreateObject("MSXML2.DOMDocument")
	oRSS.Async = False
	oRSS.Load(sChannelURL)

	ClearOldNews

	If (oRSS.parseError.errorCode <> 0) Then
		SetpropertyValue "News.News Channel Name", "Error: " & oRSS.parseError.reason
	Else
			Set Nodes = oRSS.selectNodes("//item")
			For Each Node In Nodes
				If (iCnt < iMaxItems) Then
					iCnt = iCnt + 1
					sProperty = "News.News " & iCnt & " "
					With Node
					on error resume next
					SetPropertyValue sProperty & "Headline", .selectSingleNode("title").Text
					SetPropertyValue sProperty & "Date", .selectSingleNode("pubDate").Text
					SetPropertyValue sProperty & "Text", .selectSingleNode("description").Text
					on error Goto 0              
					End With
				End If
			Next
	End If
End If

Function CheckChannel(sChannel)
	Dim iPosn

	If len(sChannel) < 1 then
		SetpropertyValue "News.News Channel Name", "Error: No Channel selection."
		CheckChannel = False
	Else
		iPosn = instr(sChannel, "|")
		If iPosn > 1 Then
			sChannelName = trim(mid(sChannel,1,iPosn-1))
			sChannelURL = trim(mid(sChannel,iPosn+1))
			If len(sChannelName) < 1 or len(sChannelURL) < 1 then
				SetpropertyValue "News.News Channel Name", "Error: No Channel name and/or URL."
				CheckChannel = False
			Else
				SetpropertyValue "News.News Channel Name", sChannelName
				SetpropertyValue "News.News Channel URL", sChannelURL
				CheckChannel = True
			End If
		Else
			SetpropertyValue "News.News Channel Name", "Error: Selected Channel data lacks a valid delimiter."
			CheckChannel = False
		End If
	End If
End Function

Sub ClearOldNews()
	For iCnt = 1 to iMaxItems
		sProperty = "News.News " & iCnt & " "
		SetPropertyValue sProperty & "Headline", ""
		SetPropertyValue sProperty & "Date", ""
		SetPropertyValue sProperty & "Text", ""
	next
	iCnt = 0
end sub
